<template>
	<div class="scrollbar" v-bind="$attrs" v-on="$listeners">
		<template v-for="slotName in Object.keys($slots)" :slot="slotName">
			<slot :name="slotName" />
		</template>
		<slot name="scrollBarContent"></slot>
		<div></div>
	</div>
</template>

<script>
export default {
	name: 'CustomScrollBar',
	inheritAttrs: false,
};
</script>

<style lang="scss" scoped>
.scrollbar {
	/* fill parent */
	display: block;
	width: 100%;
	height: 100%;

	/* set to some transparent color */
	border-color: rgba(179, 179, 179, 0);
	/* here we make the color transition */
	transition: border-color 0.3s linear;
	/* make this element do the scrolling */
	overflow: auto;
}

.scrollbar:hover {
	/* the color we want the scrollbar on hover */
	border-color: rgba(179, 179, 179, 0.3);
	transition: border-color 0.3s linear;
}

.scrollbar::-webkit-scrollbar,
.scrollbar::-webkit-scrollbar-thumb,
.scrollbar::-webkit-scrollbar-corner {
	/* add border to act as background-color */
	border-right-style: inset;
	/* sum viewport dimensions to guarantee border will fill scrollbar */
	border-right-width: calc(100vw + 100vh);
	/* inherit border-color to inherit transitions */
	border-color: inherit;
}
.scrollbar::-webkit-scrollbar {
	width: 7px;
	height: 7px;
}
</style>
